(*fastDummyprinter, Copyright (C) 2012 Laure Gonnord*)
(*This file was part of Aspic Distribution, (C) Laure Gonnord 2007*)
(*  *)
(* This library is free software; you can redistribute it and/or *)
(* modify it under the terms of the GNU Lesser General Public *)
(* License as published by the Free Software Foundation; either *)
(* version 2.1 of the License, or (at your option) any later version. *)
(*  *)
(* This library is distributed in the hope that it will be useful, *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU *)
(* Lesser General Public License for more details. *)
(*  *)
(* You should have received a copy of the GNU Lesser General Public *)
(* License along with this library; if not, write to the Free Software *)
(* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA *)
(* 02110-1301 USA *)

open Symbol
open Format

type opnum = Plus | Times | Div | Minus

type expr_num = | OpNum of opnum * expr_num * expr_num
		| Ref of Symbol.t
		| CNat of int
		| CRat of Rational.t
		| Indet of Symbol.t

type opcompare = Eq | NotEq | SupEq | LessEq | Less | Sup
    
type term = ExprNum of opcompare *  expr_num * expr_num 
	    | Stateis of Symbol.t | CBool of bool | VBool of Symbol.t
		
type opboolB = And | Or | Imply 

type expr_bool = Term of term 
		 | OpBoolB of opboolB * expr_bool * expr_bool
		 | Neg of expr_bool

val print_exprbool : Format.formatter -> expr_bool -> unit
val print_exprnum : Format.formatter -> expr_num -> unit

val exprbool2string : expr_bool -> string
val exprnum2string : expr_num -> string
