(*fastDummyprinter, Copyright (C) 2012 Laure Gonnord*)
(*  *)
(* This library is free software; you can redistribute it and/or *)
(* modify it under the terms of the GNU Lesser General Public *)
(* License as published by the Free Software Foundation; either *)
(* version 2.1 of the License, or (at your option) any later version. *)
(*  *)
(* This library is distributed in the hope that it will be useful, *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU *)
(* Lesser General Public License for more details. *)
(*  *)
(* You should have received a copy of the GNU Lesser General Public *)
(* License along with this library; if not, write to the Free Software *)
(* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA *)
(* 02110-1301 USA *)

open Format
open Types

exception NbArgs
  
let _ = 
  (
    printf "Fast File - Parsing code  @.";
    try(
      let nb_of_args = Array.length (Sys.argv) in
	if  nb_of_args <> 2 then raise NbArgs;
	let filetoparse = Sys.argv.(1) in
	  let lexbuf = Lexing.from_channel (open_in filetoparse)
	  in
	    (* Parsing *)
	  let (prog:progfast) =  Parse.parse_file
	    ~lexer:LexerFast.lexBac
	    ~parser:ParserFast.prog
		filetoparse
	  in (*pretty printing*)
	    printf "1 - parsing input file : ok @.";
	    printf "2 - construction of IR : ok @.";
	    printf "3 - pretty print :  @.";
 	    print_fast prog "auto generated" [] true std_formatter
    )
    with
      | NbArgs -> failwith "wrong number of arguments"
      | _ -> failwith "unknown error"
  )
