(* Copyright (C) 2005 Bertrand Jeannet and 2007 Laure Gonnord*)
(*  *)
(* This library is free software; you can redistribute it and/or *)
(* modify it under the terms of the GNU Lesser General Public *)
(* License as published by the Free Software Foundation; either *)
(* version 2.1 of the License, or (at your option) any later version. *)
(*  *)
(* This library is distributed in the hope that it will be useful, *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU *)
(* Lesser General Public License for more details. *)
(*  *)
(* You should have received a copy of the GNU Lesser General Public *)
(* License along with this library; if not, write to the Free Software *)
(* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA *)
(* 02110-1301 USA *)


exception Lex_error

val lex_eol : Lexing.lexbuf -> unit

val parse_lexbuf :
  lexer:(Lexing.lexbuf -> 'token) ->
  parser:((Lexing.lexbuf -> 'token) -> Lexing.lexbuf -> 'ast) ->
  Lexing.lexbuf -> 'ast

val parse_string :
  lexer:(Lexing.lexbuf -> 'token) ->
  parser:((Lexing.lexbuf -> 'token) -> Lexing.lexbuf -> 'ast) -> 
  string -> 
  'ast

val parse_file :
  lexer:(Lexing.lexbuf -> 'token) ->
  parser:((Lexing.lexbuf -> 'token) -> Lexing.lexbuf -> 'ast) -> 
  string -> 
  'ast
