(* Camllib  *)
(* Copyright (C) 2005 Bertrand Jeannet *)
(*  *)
(* This library is free software; you can redistribute it and/or *)
(* modify it under the terms of the GNU Lesser General Public *)
(* License as published by the Free Software Foundation; either *)
(* version 2.1 of the License, or (at your option) any later version. *)
(*  *)
(* This library is distributed in the hope that it will be useful, *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU *)
(* Lesser General Public License for more details. *)
(*  *)
(* You should have received a copy of the GNU Lesser General Public *)
(* License along with this library; if not, write to the Free Software *)
(* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA *)
(* 02110-1301 USA *)

(** Rational numbers *)

val gcd : int -> int -> int

type t = {
  num : int;
  den : int
}

val make : int -> int -> t

val inv : t -> t
val neg : t -> t
val add : t -> t -> t
val sub : t -> t -> t
val mul : t -> t -> t
val div : t -> t -> t
val mul_scal_int : int -> t -> t

val to_string : t -> string
val print : Format.formatter -> t -> unit
val is_positive : t -> bool
val is_one : t -> bool
val is_zero : t -> bool
val is_int : t -> bool * int

val get_num: t -> int
val get_den: t -> int

